#include "user.h"
#include <math.h>

void parameters()
{
    iopt(IOP_METHOD,VAL_GASEI);
    iopt(IOP_PR_FULL_MARK,VAL_YES);
    iopt(IOP_PR_RSET,VAL_YES);
    iopt(IOP_ITERATIONS,20);
    fopt(FOP_PRECISION,0.01);
    iopt(IOP_PR_RGRAPH,VAL_YES);
    iopt(IOP_PR_MC,VAL_YES);
    iopt(IOP_PR_PROB,VAL_YES);
    iopt(IOP_MC,VAL_CTMC);
    iopt(IOP_DEBUG,VAL_YES); 
}        


void net()
{
    place("customer");
    place("dataEntry");
    place("uploadData");
    place("waiting");
    place("requestReject");
    place("reApply");
    place("bank");
	place("bankService");
	place("dataValidation");
	place("sendingBank");
	place("preDecisionPhase");
	place("preDecisPhsResult");
	place("bankDecision");
	place("employeeProcessing");
	place("employeeDecision");
	place("supervisorProcessing");
	place("supervisorDecision");

    trans("request");
    trans("enterData");
    trans("uploading");
    trans("requestDecision");
    trans("imdReqReject");
    trans("imdReqReApply");
    trans("sendReApply");
	trans("validateData");
	trans("sendBank");
	trans("preDecisionRate");
	trans("imdBnkApproval");
	trans("imdBnkRejection");
	trans("imdBankProcessing");
	trans("empRateDecide");
	trans("imdEmpApproval");
	trans("imdEmpRejection");
	trans("supvsrRateDecide");
	trans("imdSupvsrApproval");
	trans("imdSupvsrRejection");



    rateval("request",3.11944);
    rateval("enterData",0.04667);
    rateval("uploading",0.88424);
    rateval("requestDecision",0.45729);
    rateval("sendReApply",0.02036);
	rateval("validateData",1.43141);
	rateval("sendBank",1.53785);
	rateval("preDecisionRate",5.15757);
	rateval("empRateDecide",0.01221);
	rateval("supvsrRateDecide",0.01221);
	
	
	probval("imdReqReject",0.91030);
    priority("imdReqReject", 1);
	probval("imdReqReApply",0.08970);
	priority("imdReqReApply", 1);
	probval("imdBnkApproval",0.20907);
	priority("imdBnkApproval", 1);
	probval("imdBnkRejection",0.32075);
	priority("imdBnkRejection", 1);
	probval("imdBankProcessing",0.47018);
	priority("imdBankProcessing", 1);
	probval("imdEmpApproval",0.17441);
	priority("imdEmpApproval", 1);
	probval("imdEmpRejection",0.82559);
	priority("imdEmpRejection", 1);
	probval("imdSupvsrApproval",0.56423);
	priority("imdSupvsrApproval", 1);
	probval("imdSupvsrRejection",0.43577);
	priority("imdSupvsrRejection", 1);


    
    init("customer",1);
    init("bank",1);
	init("bankService",1);

    iarc("request","customer");
    iarc("request","bank");
    iarc("enterData","dataEntry");
    iarc("uploading","uploadData");
    iarc("uploading","bankService");
    iarc("requestDecision","waiting");
    iarc("requestDecision","bankDecision");
    iarc("imdReqReject","requestReject");
    iarc("imdReqReApply","requestReject");

	iarc("sendReApply","reApply");
	iarc("validateData","dataValidation");
	iarc("sendBank","sendingBank");
	iarc("sendBank","bank");
	iarc("preDecisionRate","preDecisionPhase");
	iarc("imdBnkApproval","preDecisPhsResult");
	iarc("imdBnkRejection","preDecisPhsResult");  
	iarc("imdBankProcessing","preDecisPhsResult");
	iarc("empRateDecide","employeeProcessing");
	iarc("imdEmpApproval","employeeDecision");
	iarc("imdEmpRejection","employeeDecision");

	iarc("supvsrRateDecide","supervisorProcessing");
	iarc("imdSupvsrApproval","supervisorDecision");
	iarc("imdSupvsrRejection","supervisorDecision");



    oarc("request","dataEntry");
    oarc("request","bank");
   
    oarc("enterData","uploadData");
    oarc("uploading","waiting");
    oarc("uploading","dataValidation");
    oarc("requestDecision","customer");
    oarc("requestDecision","requestReject");
    oarc("imdReqReject","customer");
	oarc("imdReqReApply","reApply");
	oarc("sendReApply","dataEntry");

	oarc("validateData","sendingBank");
	oarc("sendBank","bankService"); 
	oarc("sendBank","preDecisionPhase");
	oarc("preDecisionRate","preDecisPhsResult");
	oarc("imdBnkApproval","bankDecision");
	oarc("imdBnkApproval","bank");
	oarc("imdBnkRejection","bankDecision");
	oarc("imdBnkRejection","bank");
	oarc("imdBankProcessing","employeeProcessing");

	oarc("empRateDecide","employeeDecision");
	oarc("imdEmpApproval","supervisorProcessing");
	oarc("imdEmpRejection","bank");
	oarc("supvsrRateDecide","supervisorDecision");
	oarc("imdSupvsrApproval","bankDecision");
	oarc("imdSupvsrApproval","bank");
	oarc("imdSupvsrRejection","bankDecision");
	oarc("imdSupvsrRejection","bank");

	//    harc("sendReApply","dataEntry");
}
 
void ac_init() {
    pr_net_info(); 
}

void ac_reach() {
    printf("The reachability graph has been generated\n");
}

int assert(){
  return 1;
}

void ac_final() {
    pr_mc_info();
    //    pr_std_average();
   // pr_expected("Utilisation",util);
  //  pr_expected("Throughput",tput);
}          

