#include "user.h"
#include <math.h>

int N,diska,diskb,Va,Vb,Vcpu;
double Sa,Sb,Scpu,Da,Db,Dcpu;
char Dmax[5];
void parameters()
{
    N=input("Number of transitions?");
    Va=input("Number visits to disk A, per transaction?");
    Vb=input("Number visits to disk B, per transaction?");
    Sa=input("Service time of disk A?");
    Sb=input("Service time of disk B?");
    Scpu=input("Service time of CPU");
    Vcpu=Va+Vb+1;
    Da=Sa*Va; Db=Sb*Vb; Dcpu=Scpu*Vcpu;
    if ((Da>=Db) && (Da>=Dcpu)) 
	sprintf(Dmax,"D%s","A");
    else 
	if ((Db>=Da) && (Db>=Dcpu)) 
	    sprintf(Dmax,"D%s","B");
	else
	    sprintf(Dmax,"%s","CPU");
    

    iopt(IOP_METHOD,VAL_GASEI);
    iopt(IOP_PR_FULL_MARK,VAL_YES);
    iopt(IOP_PR_RSET,VAL_NO);
    iopt(IOP_ITERATIONS,20000);
    fopt(FOP_PRECISION,0.00000001);
    iopt(IOP_PR_RGRAPH,VAL_NO);
    iopt(IOP_PR_MC,VAL_NO);
    iopt(IOP_PR_PROB,VAL_NO);
    iopt(IOP_MC,VAL_CTMC);
    iopt(IOP_DEBUG,VAL_NO);
}


void net()
{
   int i;
   char placen[10],transn[10];

  for (i=1;i<6;i++)
      {
          sprintf(placen,"p%d",i);
          place(placen);
          sprintf(transn,"t%d",i);
          trans(transn);
      }

  rateval("t1", 1.0/Scpu); 
  rateval("t2", 1.0/Sa);
  rateval("t3", 1.0/Sb);
  rateval("t4", 1.0 /Scpu);

  init("p1",N);
  probval("t5",1.0);
  priority("t5",1);
  

iarc("t1","p1");
iarc("t2","p2");
iarc("t3","p3");
iarc("t4","p4");
miarc("t5","p5",Va+Vb);

  moarc("t1","p2",Va);
  moarc("t1","p3",Vb);
  oarc("t2","p4");
  oarc("t3","p4");
  oarc("t4","p5");
  oarc("t5","p1");
}

int assert() {
  return(RES_NOERR);
}

void ac_init() {
    pr_net_info(); 
    printf("reached pr_net_info\n");
}

void ac_reach() {
    printf("The reachability graph has been generated\n");
}

double through()
{
    if (enabled("t1") || enabled("t4"))
	return(1.0/Scpu);
    else
	return(0.0);
}  

void ac_final() { 
    pr_mc_info();
    pr_std_average(); 
    printf("Service demand disk A = %5.3f secs.\n",Da);
    printf("Service demand disk B = %5.3f secs.\n",Db);
    printf("Service demand CPU = %5.3f secs.\n",Dcpu);
    printf("Bottleneck device = %s\n",Dmax);
    printf("Minimum response time = %5.3f secs.\n",Dcpu+Da+Db);
    pr_expected("Throughput CPU",through);
}


