//
//  user.c
//  SPNP
//
//  Created by Stephen Gilmore on 12/08/2013.
//
//

# include	<stdio.h>
# include	"const.h"
# include	"type.h"
# include	"port.h"
# include	"cspl.h"

# define	 enabling_type		int
# define	 probability_type	double
# define	 rate_type		double
# define	 reward_type		double

int	i_dum()	{return(0);}	/* to avoid lint complaints */
double	d_dum()	{return(0.0);}	/* to avoid lint complaints */

extern	double	input();
extern	void	iopt();
extern	void	fopt();
extern	void	pr_std_average();
extern  void    pr_std_cum_average();
extern	void	pr_net_info();
extern	void	pr_rg_info();
extern	void	pr_mc_info();
extern	void	pr_expected();
extern  void    pr_cum_expected();
extern	void	pr_accumulated();
extern	void	pr_hold_cond();
extern	double	expected();
extern	double	cum_expected();
extern	double	accumulated();
extern	void	hold_cond();
extern	void	Cplace();
extern	void	Cinit();
extern	void	Ctrans();
extern	void	Cpriority();
extern	void	Cenabling();
extern	void	Cdistr();
extern	void	Carc();
extern	int	Cmark();
extern	int	Cenabl();
extern	double	Crate();
extern	void	Cset_prob0();

void	place(s)
char *s;
{Cplace(s,1,1); }

void	place_0(s)
char *s;
{Cplace(s,1,1); }

void	place_1(s,x)
char *s;	int x;
{Cplace(s,x,1); }

void	place_2(s,x,y)
char *s;	int x,y;
{Cplace(s,x,y); }

void	init(s,n)
char *s;	int n;
{Cinit(s,0,0,n); }

void	init_0(s,n)
char *s;	int n;
{Cinit(s,0,0,n); }

void	init_1(s,x,n)
char *s;	int n,x;
{Cinit(s,x,0,n); }

void	init_2(s,x,y,n)
char *s;	int n,x,y;
{Cinit(s,x,y,n); }

void	trans(s)
char *s;
{Ctrans(s,1,1); }

void	trans_0(s)
char *s;
{Ctrans(s,1,1); }

void	trans_1(s,x)
char *s;	int x;
{Ctrans(s,x,1); }

void	trans_2(s,x,y)
char *s;	int x,y;
{Ctrans(s,x,y); }

void	priority(s,prio)
char *s;	int prio;
{Cpriority(s,0,0,prio); }

void	priority_0(s,prio)
char *s;	int prio;
{Cpriority(s,0,0,prio); }

void	priority_1(s,x,prio)
char *s;	int x,prio;
{Cpriority(s,x,0,prio); }

void	priority_2(s,x,y,prio)
char *s;	int x,y,prio;
{Cpriority(s,x,y,prio); }

void	enabling(s,en)
char *s;	int (*en)();
{Cenabling(s,0,0,en); }

void	enabling_0(s,en)
char *s;	int (*en)();
{Cenabling(s,0,0,en); }

void	enabling_1(s,x,en)
char *s;	int x,(*en)();
{Cenabling(s,x,0,en); }

void	enabling_2(s,x,y,en)
char *s;	int x,y,(*en)();
{Cenabling(s,x,y,en); }

void	probval(s,v)
char *s;			double v;
{Cdistr(DIS_IMM,s,0,0,DEP_NO,v,0.0,"",0,0,d_dum,d_dum);}

void	probval_0(s,v)
char *s;			double v;
{Cdistr(DIS_IMM,s,0,0,DEP_NO,v,0.0,"",0,0,d_dum,d_dum);}

void	probval_1(s,x,v)
char *s;	int x;		double v;
{Cdistr(DIS_IMM,s,x,0,DEP_NO,v,0.0,"",0,0,d_dum,d_dum);}

void	probval_2(s,x,y,v)
char *s;	int x,y;	double v;
{Cdistr(DIS_IMM,s,x,y,DEP_NO,v,0.0,"",0,0,d_dum,d_dum);}

void	rateval(s,v)
char *s;			double v;
{Cdistr(DIS_EXP,s,0,0,DEP_NO,v,0.0,"",0,0,d_dum,d_dum);}

void	rateval_0(s,v)
char *s;			double v;
{Cdistr(DIS_EXP,s,0,0,DEP_NO,v,0.0,"",0,0,d_dum,d_dum);}

void	rateval_1(s,x,v)
char *s;	int x;		double v;
{Cdistr(DIS_EXP,s,x,0,DEP_NO,v,0.0,"",0,0,d_dum,d_dum);}

void	rateval_2(s,x,y,v)
char *s;	int x,y;	double v;
{Cdistr(DIS_EXP,s,x,y,DEP_NO,v,0.0,"",0,0,d_dum,d_dum);}

void	probdep(s,v,p)
char *s,*p;			double v;
{Cdistr(DIS_IMM,s,0,0,DEP_PL,v,0.0,p,0,0,d_dum,d_dum); }

void	probdep_0_0(s,v,p)
char *s,*p;			double v;
{Cdistr(DIS_IMM,s,0,0,DEP_PL,v,0.0,p,0,0,d_dum,d_dum); }

void	probdep_1_0(s,x,v,p)
char *s,*p;	int x;		double v;
{Cdistr(DIS_IMM,s,x,0,DEP_PL,v,0.0,p,0,0,d_dum,d_dum); }

void	probdep_2_0(s,x,y,v,p)
char *s,*p;	int x,y;	double v;
{Cdistr(DIS_IMM,s,x,y,DEP_PL,v,0.0,p,0,0,d_dum,d_dum); }

void	probdep_0_1(s,v,p,t)
char *s,*p;	int t;		double v;
{Cdistr(DIS_IMM,s,0,0,DEP_PL,v,0.0,p,t,0,d_dum,d_dum); }

void	probdep_1_1(s,x,v,p,t)
char *s,*p;	int x,t;	double v;
{Cdistr(DIS_IMM,s,x,0,DEP_PL,v,0.0,p,t,0,d_dum,d_dum); }

void	probdep_2_1(s,x,y,v,p,t)
char *s,*p;	int x,y,t;	double v;
{Cdistr(DIS_IMM,s,x,y,DEP_PL,v,0.0,p,t,0,d_dum,d_dum); }

void	probdep_0_2(s,v,p,t,u)
char *s,*p;	int t,u;	double v;
{Cdistr(DIS_IMM,s,0,0,DEP_PL,v,0.0,p,t,u,d_dum,d_dum); }

void	probdep_1_2(s,x,v,p,t,u)
char *s,*p;	int x,t,u;	double v;
{Cdistr(DIS_IMM,s,x,0,DEP_PL,v,0.0,p,t,u,d_dum,d_dum); }

void	probdep_2_2(s,x,y,v,p,t,u)
char *s,*p;	int x,y,t,u;	double v;
{Cdistr(DIS_IMM,s,x,y,DEP_PL,v,0.0,p,t,u,d_dum,d_dum); }

void	ratedep(s,v,p)
char *s,*p;			double v;
{Cdistr(DIS_EXP,s,0,0,DEP_PL,v,0.0,p,0,0,d_dum,d_dum); }

void	ratedep_0_0(s,v,p)
char *s,*p;			double v;
{Cdistr(DIS_EXP,s,0,0,DEP_PL,v,0.0,p,0,0,d_dum,d_dum); }

void	ratedep_1_0(s,x,v,p)
char *s,*p;	int x;		double v;
{Cdistr(DIS_EXP,s,x,0,DEP_PL,v,0.0,p,0,0,d_dum,d_dum); }

void	ratedep_2_0(s,x,y,v,p)
char *s,*p;	int x,y;	double v;
{Cdistr(DIS_EXP,s,x,y,DEP_PL,v,0.0,p,0,0,d_dum,d_dum); }

void	ratedep_0_1(s,v,p,t)
char *s,*p;	int t;		double v;
{Cdistr(DIS_EXP,s,0,0,DEP_PL,v,0.0,p,t,0,d_dum,d_dum); }

void	ratedep_1_1(s,x,v,p,t)
char *s,*p;	int x,t;	double v;
{Cdistr(DIS_EXP,s,x,0,DEP_PL,v,0.0,p,t,0,d_dum,d_dum); }

void	ratedep_2_1(s,x,y,v,p,t)
char *s,*p;	int x,y,t;	double v;
{Cdistr(DIS_EXP,s,x,y,DEP_PL,v,0.0,p,t,0,d_dum,d_dum); }

void	ratedep_0_2(s,v,p,t,u)
char *s,*p;	int t,u;	double v;
{Cdistr(DIS_EXP,s,0,0,DEP_PL,v,0.0,p,t,u,d_dum,d_dum); }

void	ratedep_1_2(s,x,v,p,t,u)
char *s,*p;	int x,t,u;	double v;
{Cdistr(DIS_EXP,s,x,0,DEP_PL,v,0.0,p,t,u,d_dum,d_dum); }

void	ratedep_2_2(s,x,y,v,p,t,u)
char *s,*p;	int x,y,t,u;	double v;
{Cdistr(DIS_EXP,s,x,y,DEP_PL,v,0.0,p,t,u,d_dum,d_dum); }

void	probfun(s,f)
char *s;			double (*f)();
{Cdistr(DIS_IMM,s,0,0,DEP_MK,0.0,0.0,"",0,0,f,d_dum); }

void	probfun_0(s,f)
char *s;			double (*f)();
{Cdistr(DIS_IMM,s,0,0,DEP_MK,0.0,0.0,"",0,0,f,d_dum); }

void	probfun_1(s,x,f)
char *s;	int x;		double (*f)();
{Cdistr(DIS_IMM,s,x,0,DEP_MK,0.0,0.0,"",0,0,f,d_dum); }

void	probfun_2(s,x,y,f)
char *s;	int x,y;	double (*f)();
{Cdistr(DIS_IMM,s,x,y,DEP_MK,0.0,0.0,"",0,0,f,d_dum); }

void	ratefun(s,f)
char *s;			double (*f)();
{Cdistr(DIS_EXP,s,0,0,DEP_MK,0.0,0.0,"",0,0,f,d_dum); }

void	ratefun_0(s,f)
char *s;			double (*f)();
{Cdistr(DIS_EXP,s,0,0,DEP_MK,0.0,0.0,"",0,0,f,d_dum); }

void	ratefun_1(s,x,f)
char *s;	int x;		double (*f)();
{Cdistr(DIS_EXP,s,x,0,DEP_MK,0.0,0.0,"",0,0,f,d_dum); }

void	ratefun_2(s,x,y,f)
char *s;	int x,y;	double (*f)();
{Cdistr(DIS_EXP,s,x,y,DEP_MK,0.0,0.0,"",0,0,f,d_dum); }

void	sprobval(s,v,dv)
char *s;			double v;
{Cdistr(DIS_IMM,s,0,0,DEP_NO,v,dv,"",0,0,d_dum,d_dum); }

void	sprobval_0(s,v,dv)
char *s;			double v,dv;
{Cdistr(DIS_IMM,s,0,0,DEP_NO,v,dv,"",0,0,d_dum,d_dum); }

void	sprobval_1(s,x,v,dv)
char *s;	int x;		double v,dv;
{Cdistr(DIS_IMM,s,x,0,DEP_NO,v,dv,"",0,0,d_dum,d_dum); }

void	sprobval_2(s,x,y,v,dv)
char *s;	int x,y;	double v,dv;
{Cdistr(DIS_IMM,s,x,y,DEP_NO,v,dv,"",0,0,d_dum,d_dum); }

void	srateval(s,v,dv)
char *s;			double v,dv;
{Cdistr(DIS_EXP,s,0,0,DEP_NO,v,dv,"",0,0,d_dum,d_dum);}

void	srateval_0(s,v,dv)
char *s;			double v,dv;
{Cdistr(DIS_EXP,s,0,0,DEP_NO,v,dv,"",0,0,d_dum,d_dum);}

void	srateval_1(s,x,v,dv)
char *s;	int x;		double v,dv;
{Cdistr(DIS_EXP,s,x,0,DEP_NO,v,dv,"",0,0,d_dum,d_dum);}

void	srateval_2(s,x,y,v,dv)
char *s;	int x,y;	double v,dv;
{Cdistr(DIS_EXP,s,x,y,DEP_NO,v,dv,"",0,0,d_dum,d_dum);}

void	sprobdep(s,v,dv,p)
char *s,*p;			double v,dv;
{Cdistr(DIS_IMM,s,0,0,DEP_PL,v,dv,p,0,0,d_dum,d_dum); }

void	sprobdep_0_0(s,v,dv,p)
char *s,*p;			double v,dv;
{Cdistr(DIS_IMM,s,0,0,DEP_PL,v,dv,p,0,0,d_dum,d_dum); }

void	sprobdep_1_0(s,x,v,dv,p)
char *s,*p;	int x;		double v,dv;
{Cdistr(DIS_IMM,s,x,0,DEP_PL,v,dv,p,0,0,d_dum,d_dum); }

void	sprobdep_2_0(s,x,y,v,dv,p)
char *s,*p;	int x,y;	double v,dv;
{Cdistr(DIS_IMM,s,x,y,DEP_PL,v,dv,p,0,0,d_dum,d_dum); }

void	sprobdep_0_1(s,v,dv,p,t)
char *s,*p;	int t;		double v,dv;
{Cdistr(DIS_IMM,s,0,0,DEP_PL,v,dv,p,t,0,d_dum,d_dum); }

void	sprobdep_1_1(s,x,v,dv,p,t)
char *s,*p;	int x,t;	double v,dv;
{Cdistr(DIS_IMM,s,x,0,DEP_PL,v,dv,p,t,0,d_dum,d_dum); }

void	sprobdep_2_1(s,x,y,v,dv,p,t)
char *s,*p;	int x,y,t;	double v,dv;
{Cdistr(DIS_IMM,s,x,y,DEP_PL,v,dv,p,t,0,d_dum,d_dum); }

void	sprobdep_0_2(s,v,dv,p,t,u)
char *s,*p;	int t,u;	double v,dv;
{Cdistr(DIS_IMM,s,0,0,DEP_PL,v,dv,p,t,u,d_dum,d_dum); }

void	sprobdep_1_2(s,x,v,dv,p,t,u)
char *s,*p;	int x,t,u;	double v,dv;
{Cdistr(DIS_IMM,s,x,0,DEP_PL,v,dv,p,t,u,d_dum,d_dum); }

void	sprobdep_2_2(s,x,y,v,dv,p,t,u)
char *s,*p;	int x,y,t,u;	double v,dv;
{Cdistr(DIS_IMM,s,x,y,DEP_PL,v,dv,p,t,u,d_dum,d_dum); }

void	sratedep(s,v,dv,p)
char *s,*p;			double v,dv;
{Cdistr(DIS_EXP,s,0,0,DEP_PL,v,dv,p,0,0,d_dum,d_dum); }

void	sratedep_0_0(s,v,dv,p)
char *s,*p;			double v,dv;
{Cdistr(DIS_EXP,s,0,0,DEP_PL,v,dv,p,0,0,d_dum,d_dum); }

void	sratedep_1_0(s,x,v,dv,p)
char *s,*p;	int x;		double v,dv;
{Cdistr(DIS_EXP,s,x,0,DEP_PL,v,dv,p,0,0,d_dum,d_dum); }

void	sratedep_2_0(s,x,y,v,dv,p)
char *s,*p;	int x,y;	double v,dv;
{Cdistr(DIS_EXP,s,x,y,DEP_PL,v,dv,p,0,0,d_dum,d_dum); }

void	sratedep_0_1(s,v,dv,p,t)
char *s,*p;	int t;		double v,dv;
{Cdistr(DIS_EXP,s,0,0,DEP_PL,v,dv,p,t,0,d_dum,d_dum); }

void	sratedep_1_1(s,x,v,dv,p,t)
char *s,*p;	int x,t;	double v,dv;
{Cdistr(DIS_EXP,s,x,0,DEP_PL,v,dv,p,t,0,d_dum,d_dum); }

void	sratedep_2_1(s,x,y,v,dv,p,t)
char *s,*p;	int x,y,t;	double v,dv;
{Cdistr(DIS_EXP,s,x,y,DEP_PL,v,dv,p,t,0,d_dum,d_dum); }

void	sratedep_0_2(s,v,dv,p,t,u)
char *s,*p;	int t,u;	double v,dv;
{Cdistr(DIS_EXP,s,0,0,DEP_PL,v,dv,p,t,u,d_dum,d_dum); }

void	sratedep_1_2(s,x,v,dv,p,t,u)
char *s,*p;	int x,t,u;	double v,dv;
{Cdistr(DIS_EXP,s,x,0,DEP_PL,v,dv,p,t,u,d_dum,d_dum); }

void	sratedep_2_2(s,x,y,v,dv,p,t,u)
char *s,*p;	int x,y,t,u;	double v,dv;
{Cdistr(DIS_EXP,s,x,y,DEP_PL,v,dv,p,t,u,d_dum,d_dum); }

void	sprobfun(s,f,df)
char *s;			double (*f)(),(*df)();
{Cdistr(DIS_IMM,s,0,0,DEP_MK,0.0,0.0,"",0,0,f,df); }

void	sprobfun_0(s,f,df)
char *s;			double (*f)(),(*df)();
{Cdistr(DIS_IMM,s,0,0,DEP_MK,0.0,0.0,"",0,0,f,df); }

void	sprobfun_1(s,x,f,df)
char *s;	int x;		double (*f)(),(*df)();
{Cdistr(DIS_IMM,s,x,0,DEP_MK,0.0,0.0,"",0,0,f,df); }

void	sprobfun_2(s,x,y,f,df)
char *s;	int x,y;	double (*f)(),(*df)();
{Cdistr(DIS_IMM,s,x,y,DEP_MK,0.0,0.0,"",0,0,f,df); }

void	sratefun(s,f,df)
char *s;			double (*f)(),(*df)();
{Cdistr(DIS_EXP,s,0,0,DEP_MK,0.0,0.0,"",0,0,f,df); }

void	sratefun_0(s,f,df)
char *s;			double (*f)(),(*df)();
{Cdistr(DIS_EXP,s,0,0,DEP_MK,0.0,0.0,"",0,0,f,df); }

void	sratefun_1(s,x,f,df)
char *s;	int x;		double (*f)(),(*df)();
{Cdistr(DIS_EXP,s,x,0,DEP_MK,0.0,0.0,"",0,0,f,df); }

void	sratefun_2(s,x,y,f,df)
char *s;	int x,y;	double (*f)(),(*df)();
{Cdistr(DIS_EXP,s,x,y,DEP_MK,0.0,0.0,"",0,0,f,df); }

void	iarc(a,b)
char *a,*b;
{Carc(ARC_I,a,0,0,b,0,0,1,i_dum); }

void	iarc_0_0(a,b)
char *a,*b;
{Carc(ARC_I,a,0,0,b,0,0,1,i_dum); }

void	iarc_0_1(a,b,t)
char *a,*b;	int t;
{Carc(ARC_I,a,0,0,b,t,0,1,i_dum); }

void	iarc_0_2(a,b,t,u)
char *a,*b;	int t,u;
{Carc(ARC_I,a,0,0,b,t,u,1,i_dum); }

void	iarc_1_0(a,x,b)
char *a,*b;	int x;
{Carc(ARC_I,a,x,0,b,0,0,1,i_dum); }

void	iarc_1_1(a,x,b,t)
char *a,*b;	int x,t;
{Carc(ARC_I,a,x,0,b,t,0,1,i_dum); }

void	iarc_1_2(a,x,b,t,u)
char *a,*b;	int x,t,u;
{Carc(ARC_I,a,x,0,b,t,u,1,i_dum); }

void	iarc_2_0(a,x,y,b)
char *a,*b;	int x,y;
{Carc(ARC_I,a,x,y,b,0,0,1,i_dum); }

void	iarc_2_1(a,x,y,b,t)
char *a,*b;	int x,y,t;
{Carc(ARC_I,a,x,y,b,t,0,1,i_dum); }

void	iarc_2_2(a,x,y,b,t,u)
char *a,*b;	int x,y,t,u;
{Carc(ARC_I,a,x,y,b,t,u,1,i_dum); }

void	oarc(a,b)
char *a,*b;
{Carc(ARC_O,a,0,0,b,0,0,1,i_dum); }

void	oarc_0_0(a,b)
char *a,*b;
{Carc(ARC_O,a,0,0,b,0,0,1,i_dum); }

void	oarc_0_1(a,b,t)
char *a,*b;	int t;
{Carc(ARC_O,a,0,0,b,t,0,1,i_dum); }

void	oarc_0_2(a,b,t,u)
char *a,*b;	int t,u;
{Carc(ARC_O,a,0,0,b,t,u,1,i_dum); }

void	oarc_1_0(a,x,b)
char *a,*b;	int x;
{Carc(ARC_O,a,x,0,b,0,0,1,i_dum); }

void	oarc_1_1(a,x,b,t)
char *a,*b;	int x,t;
{Carc(ARC_O,a,x,0,b,t,0,1,i_dum); }

void	oarc_1_2(a,x,b,t,u)
char *a,*b;	int x,t,u;
{Carc(ARC_O,a,x,0,b,t,u,1,i_dum); }

void	oarc_2_0(a,x,y,b)
char *a,*b;	int x,y;
{Carc(ARC_O,a,x,y,b,0,0,1,i_dum); }

void	oarc_2_1(a,x,y,b,t)
char *a,*b;	int x,y,t;
{Carc(ARC_O,a,x,y,b,t,0,1,i_dum); }

void	oarc_2_2(a,x,y,b,t,u)
char *a,*b;	int x,y,t,u;
{Carc(ARC_O,a,x,y,b,t,u,1,i_dum); }

void	harc(a,b)
char *a,*b;
{Carc(ARC_H,a,0,0,b,0,0,1,i_dum); }

void	harc_0_0(a,b)
char *a,*b;
{Carc(ARC_H,a,0,0,b,0,0,1,i_dum); }

void	harc_0_1(a,b,t)
char *a,*b;	int t;
{Carc(ARC_H,a,0,0,b,t,0,1,i_dum); }

void	harc_0_2(a,b,t,u)
char *a,*b;	int t,u;
{Carc(ARC_H,a,0,0,b,t,u,1,i_dum); }

void	harc_1_0(a,x,b)
char *a,*b;	int x;
{Carc(ARC_H,a,x,0,b,0,0,1,i_dum); }

void	harc_1_1(a,x,b,t)
char *a,*b;	int x,t;
{Carc(ARC_H,a,x,0,b,t,0,1,i_dum); }

void	harc_1_2(a,x,b,t,u)
char *a,*b;	int x,t,u;
{Carc(ARC_H,a,x,0,b,t,u,1,i_dum); }

void	harc_2_0(a,x,y,b)
char *a,*b;	int x,y;
{Carc(ARC_H,a,x,y,b,0,0,1,i_dum); }

void	harc_2_1(a,x,y,b,t)
char *a,*b;	int x,y,t;
{Carc(ARC_H,a,x,y,b,t,0,1,i_dum); }

void	harc_2_2(a,x,y,b,t,u)
char *a,*b;	int x,y,t,u;
{Carc(ARC_H,a,x,y,b,t,u,1,i_dum); }

void	miarc(a,b,m)
char *a,*b;	int m;
{Carc(ARC_I,a,0,0,b,0,0,m,i_dum); }

void	miarc_0_0(a,b,m)
char *a,*b;	int m;
{Carc(ARC_I,a,0,0,b,0,0,m,i_dum); }

void	miarc_0_1(a,b,t,m)
char *a,*b;	int m,t;
{Carc(ARC_I,a,0,0,b,t,0,m,i_dum); }

void	miarc_0_2(a,b,t,u,m)
char *a,*b;	int m,t,u;
{Carc(ARC_I,a,0,0,b,t,u,m,i_dum); }

void	miarc_1_0(a,x,b,m)
char *a,*b;	int x,m;
{Carc(ARC_I,a,x,0,b,0,0,m,i_dum); }

void	miarc_1_1(a,x,b,t,m)
char *a,*b;	int x,m,t;
{Carc(ARC_I,a,x,0,b,t,0,m,i_dum); }

void	miarc_1_2(a,x,b,t,u,m)
char *a,*b;	int x,m,t,u;
{Carc(ARC_I,a,x,0,b,t,u,m,i_dum); }

void	miarc_2_0(a,x,y,b,m)
char *a,*b;	int x,y,m;
{Carc(ARC_I,a,x,y,b,0,0,m,i_dum); }

void	miarc_2_1(a,x,y,b,t,m)
char *a,*b;	int x,y,m,t;
{Carc(ARC_I,a,x,y,b,t,0,m,i_dum); }

void	miarc_2_2(a,x,y,b,t,u,m)
char *a,*b;	int x,y,m,t,u;
{Carc(ARC_I,a,x,y,b,t,u,m,i_dum); }

void	moarc(a,b,m)
char *a,*b;	int m;
{Carc(ARC_O,a,0,0,b,0,0,m,i_dum); }

void	moarc_0_0(a,b,m)
char *a,*b;	int m;
{Carc(ARC_O,a,0,0,b,0,0,m,i_dum); }

void	moarc_0_1(a,b,t,m)
char *a,*b;	int m,t;
{Carc(ARC_O,a,0,0,b,t,0,m,i_dum); }

void	moarc_0_2(a,b,t,u,m)
char *a,*b;	int m,t,u;
{Carc(ARC_O,a,0,0,b,t,u,m,i_dum); }

void	moarc_1_0(a,x,b,m)
char *a,*b;	int m,x;
{Carc(ARC_O,a,x,0,b,0,0,m,i_dum); }

void	moarc_1_1(a,x,b,t,m)
char *a,*b;	int m,x,t;
{Carc(ARC_O,a,x,0,b,t,0,m,i_dum); }

void	moarc_1_2(a,x,b,t,u,m)
char *a,*b;	int m,x,t,u;
{Carc(ARC_O,a,x,0,b,t,u,m,i_dum); }

void	moarc_2_0(a,x,y,b,m)
char *a,*b;	int m,x,y;
{Carc(ARC_O,a,x,y,b,0,0,m,i_dum); }

void	moarc_2_1(a,x,y,b,t,m)
char *a,*b;	int m,x,y,t;
{Carc(ARC_O,a,x,y,b,t,0,m,i_dum); }

void	moarc_2_2(a,x,y,b,t,u,m)
char *a,*b;	int m,x,y,t,u;
{Carc(ARC_O,a,x,y,b,t,u,m,i_dum); }

void	mharc(a,b,m)
char *a,*b;	int m;
{Carc(ARC_H,a,0,0,b,0,0,m,i_dum); }

void	mharc_0_0(a,b,m)
char *a,*b;	int m;
{Carc(ARC_H,a,0,0,b,0,0,m,i_dum); }

void	mharc_0_1(a,b,t,m)
char *a,*b;	int m,t;
{Carc(ARC_H,a,0,0,b,t,0,m,i_dum); }

void	mharc_0_2(a,b,t,u,m)
char *a,*b;	int m,t,u;
{Carc(ARC_H,a,0,0,b,t,u,m,i_dum); }

void	mharc_1_0(a,x,b,m)
char *a,*b;	int m,x;
{Carc(ARC_H,a,x,0,b,0,0,m,i_dum); }

void	mharc_1_1(a,x,b,t,m)
char *a,*b;	int m,x,t;
{Carc(ARC_H,a,x,0,b,t,0,m,i_dum); }

void	mharc_1_2(a,x,b,t,u,m)
char *a,*b;	int m,x,t,u;
{Carc(ARC_H,a,x,0,b,t,u,m,i_dum); }

void	mharc_2_0(a,x,y,b,m)
char *a,*b;	int m,x,y;
{Carc(ARC_H,a,x,y,b,0,0,m,i_dum); }

void	mharc_2_1(a,x,y,b,t,m)
char *a,*b;	int m,x,y,t;
{Carc(ARC_H,a,x,y,b,t,0,m,i_dum); }

void	mharc_2_2(a,x,y,b,t,u,m)
char *a,*b;	int m,x,y,t,u;
{Carc(ARC_H,a,x,y,b,t,u,m,i_dum); }

void	viarc(a,b,m)
char *a,*b;	int (*m)();
{Carc(ARC_I,a,0,0,b,0,0,VARIABLE,m); }

void	viarc_0_0(a,b,m)
char *a,*b;	int (*m)();
{Carc(ARC_I,a,0,0,b,0,0,VARIABLE,m); }

void	viarc_0_1(a,b,t,m)
char *a,*b;	int (*m)(),t;
{Carc(ARC_I,a,0,0,b,t,0,VARIABLE,m); }

void	viarc_0_2(a,b,t,u,m)
char *a,*b;	int (*m)(),t,u;
{Carc(ARC_I,a,0,0,b,t,u,VARIABLE,m); }

void	viarc_1_0(a,x,b,m)
char *a,*b;	int (*m)(),x;
{Carc(ARC_I,a,x,0,b,0,0,VARIABLE,m); }

void	viarc_1_1(a,x,b,t,m)
char *a,*b;	int (*m)(),x,t;
{Carc(ARC_I,a,x,0,b,t,0,VARIABLE,m); }

void	viarc_1_2(a,x,b,t,u,m)
char *a,*b;	int (*m)(),x,t,u;
{Carc(ARC_I,a,x,0,b,t,u,VARIABLE,m); }

void	viarc_2_0(a,x,y,b,m)
char *a,*b;	int (*m)(),x,y;
{Carc(ARC_I,a,x,y,b,0,0,VARIABLE,m); }

void	viarc_2_1(a,x,y,b,t,m)
char *a,*b;	int (*m)(),x,y,t;
{Carc(ARC_I,a,x,y,b,t,0,VARIABLE,m); }

void	viarc_2_2(a,x,y,b,t,u,m)
char *a,*b;	int (*m)(),x,y,t,u;
{Carc(ARC_I,a,x,y,b,t,u,VARIABLE,m); }

void	voarc(a,b,m)
char *a,*b;	int (*m)();
{Carc(ARC_O,a,0,0,b,0,0,VARIABLE,m); }

void	voarc_0_0(a,b,m)
char *a,*b;	int (*m)();
{Carc(ARC_O,a,0,0,b,0,0,VARIABLE,m); }

void	voarc_0_1(a,b,t,m)
char *a,*b;	int (*m)(),t;
{Carc(ARC_O,a,0,0,b,t,0,VARIABLE,m); }

void	voarc_0_2(a,b,t,u,m)
char *a,*b;	int (*m)(),t,u;
{Carc(ARC_O,a,0,0,b,t,u,VARIABLE,m); }

void	voarc_1_0(a,x,b,m)
char *a,*b;	int (*m)(),x;
{Carc(ARC_O,a,x,0,b,0,0,VARIABLE,m); }

void	voarc_1_1(a,x,b,t,m)
char *a,*b;	int (*m)(),x,t;
{Carc(ARC_O,a,x,0,b,t,0,VARIABLE,m); }

void	voarc_1_2(a,x,b,t,u,m)
char *a,*b;	int (*m)(),x,t,u;
{Carc(ARC_O,a,x,0,b,t,u,VARIABLE,m); }

void	voarc_2_0(a,x,y,b,m)
char *a,*b;	int (*m)(),x,y;
{Carc(ARC_O,a,x,y,b,0,0,VARIABLE,m); }

void	voarc_2_1(a,x,y,b,t,m)
char *a,*b;	int (*m)(),x,y,t;
{Carc(ARC_O,a,x,y,b,t,0,VARIABLE,m); }

void	voarc_2_2(a,x,y,b,t,u,m)
char *a,*b;	int (*m)(),x,y,t,u;
{Carc(ARC_O,a,x,y,b,t,u,VARIABLE,m); }

void	vharc(a,b,m)
char *a,*b;	int (*m)();
{Carc(ARC_H,a,0,0,b,0,0,VARIABLE,m); }

void	vharc_0_0(a,b,m)
char *a,*b;	int (*m)();
{Carc(ARC_H,a,0,0,b,0,0,VARIABLE,m); }

void	vharc_0_1(a,b,t,m)
char *a,*b;	int (*m)(),t;
{Carc(ARC_H,a,0,0,b,t,0,VARIABLE,m); }

void	vharc_0_2(a,b,t,u,m)
char *a,*b;	int (*m)(),t,u;
{Carc(ARC_H,a,0,0,b,t,u,VARIABLE,m); }

void	vharc_1_0(a,x,b,m)
char *a,*b;	int (*m)(),x;
{Carc(ARC_H,a,x,0,b,0,0,VARIABLE,m); }

void	vharc_1_1(a,x,b,t,m)
char *a,*b;	int (*m)(),x,t;
{Carc(ARC_H,a,x,0,b,t,0,VARIABLE,m); }

void	vharc_1_2(a,x,b,t,u,m)
char *a,*b;	int (*m)(),x,t,u;
{Carc(ARC_H,a,x,0,b,t,u,VARIABLE,m); }

void	vharc_2_0(a,x,y,b,m)
char *a,*b;	int (*m)(),x,y;
{Carc(ARC_H,a,x,y,b,0,0,VARIABLE,m); }

void	vharc_2_1(a,x,y,b,t,m)
char *a,*b;	int (*m)(),x,y,t;
{Carc(ARC_H,a,x,y,b,t,0,VARIABLE,m); }

void	vharc_2_2(a,x,y,b,t,u,m)
char *a,*b;	int (*m)(),x,y,t,u;
{Carc(ARC_H,a,x,y,b,t,u,VARIABLE,m); }

int	mark(pl)
char *pl;
{return(Cmark(pl,0,0)); }

int	mark_0(pl)
char *pl;
{return(Cmark(pl,0,0)); }

int	mark_1(pl,x)
char *pl;	int x;
{return(Cmark(pl,x,0)); }

int	mark_2(pl,x,y)
char *pl;	int x,y;
{return(Cmark(pl,x,y)); }

int	enabled(tr)
char *tr;
{return(Cenabled(tr,0,0)); }

int	enabled_0(tr)
char *tr;
{return(Cenabled(tr,0,0)); }

int	enabled_1(tr,x)
char *tr;	int x;
{return(Cenabled(tr,x,0)); }

int	enabled_2(tr,x,y)
char *tr;	int x,y;
{return(Cenabled(tr,x,y)); }

double	rate(tr)
char *tr;
{return(Crate(tr,0,0)); }

double	rate_0(tr)
char *tr;
{return(Crate(tr,0,0)); }

double	rate_1(tr,x)
char *tr;	int x;
{return(Crate(tr,x,0)); }

double	rate_2(tr,x,y)
char *tr;	int x,y;
{return(Crate(tr,x,y)); }

void	set_prob0(f)
double	(*f)();
{Cset_prob0(VAL_NO,f); }

void	scale_prob0(f)
double	(*f)();
{Cset_prob0(VAL_YES,f); }

