
/*************************************************************************
FILE:	var.h
*/

# ifdef MAIN
# define	EX
# else
# define	EX	extern
# endif

/*************************************************************************
This file contains the declarations for the global variables of the package
*/

/*	This variables are set at the beginning using the user file.	*/

EX	int	Direction;
/* VAL_FROMTO, VAL_TOFROM, or VAL_NOVAL, current direction of matrix */

EX	int	DerDirection;
/* VAL_FROMTO, VAL_TOFROM, or VAL_NOVAL, current direction of matrix */

EX	int	Nplace;
/* set to 0, the number of places in the net */

EX	int	Ntrans;
/* set to 0, the number of transitions in the net */

EX	PL	*Arrplace;
/* set to NULL, the array of places (user order) */

EX	TR	*Arrtrans;
/* set to NULL, the array of transitions (user order) */

EX	ME	*Currmark;
/* pointer to the current marking, when calling marking dependent functions */

EX	ME	*Pcan;
/* pointer to the list of markings in canonical order */

EX	ME	*Proot;
/* pointer to the AVL-tree markings */

EX	LL	*Vloop;
/* pointer to the list ov vanishing loops */

EX	int	Ntottan;
/* Total number of tangible markings */

EX	int	Ntan;
/* Number of tangible non absorbing markings */

EX	int	Nabs;
/* Number of tangible absorbing markings */

EX	int	Nvan;
/* Number of vanishing markings */

EX	int	Narcs;
/* Number of (reachability graph) marking to marking transitions */

EX	int	Find;
/* First index for the states in the Markov chain */

EX	int	Nstates;
/* Number of states in the Markov chain */

EX	int	Nentries;
/* Number of entries in the Markov chain */

EX	int	Nderentries;
/* Number of entries in the Markov chain */

EX	int	Method_transient;
/* Number of entries in the Markov chain */

EX	int	Method_sensitivity;
/* Number of entries in the Markov chain */

EX	FILE	*Outfile;
/* file where the output for the user is printed */

EX	FILE	*Mcfile;
/* file where the MC is printed */

EX	FILE	*Prbfile;
/* file where the probabilities are printed */

EX	double	*Holding;
/* array of the holding times for the tangible markings */

EX	int	*IP;
/* describes the MC */

EX	int	*JA;
/* describes the MC */

EX	double	*A;
/* describes the MC */

EX	int	*DIP;
/* describes the MC */

EX	int	*DJA;
/* describes the MC */

EX	double	*DA;
/* describes the MC */

EX	int	Iterations;
/* Iterations for the MC solution */

EX	double	Precision;
/* Precision of the MC solution */

EX	double	*DProb;
/* array of the probabilities for the markings (DTMC) */

EX	double	*CProb;
/* array of the probabilities for the tangible markings (CTMC) */

EX	double	*DerCProb;
/* array of the derivative probabilities for the tangible markings (CTMC) */

EX    double  *Prob_init;
/* array of the initial distribution probabilities for the CTMC */

EX    double  *Cumprob;
/* array of the cumulative probabilities for the markings */

EX    double  *DerCumprob;
/* array of the derivative of cumulative probabilities for the markings */

EX	EE	**Qrow;
/* pointer to the rows of the reachability graph */

EX	EE	**Qcol;
/* pointer to the columns of the reachability graph */

EX	EE	**DerQrow;
/* pointer to the derivatives of rows of the reachability graph */

EX	EE	**DerQcol;
/* pointer to the derivatives of columns of the reachability graph */

EX	char	*model_name;
/* pointer to argv[1] which specifies the name of the spn file */

EX	double	Time;
/*  time value used in computing transient measures */

EX	ID	IOpt[N_IOP]
# ifdef MAIN
= {
{"IOP_PR_MARK_ORDER",
	{VAL_CANONIC, VAL_LEXICAL, VAL_MATRIX, VAL_NOVAL},
	VAL_CANONIC},
{"IOP_PR_MERG_MARK",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_YES},
{"IOP_PR_FULL_MARK",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_NO},
{"IOP_PR_RSET",
	{VAL_YES, VAL_NO, VAL_TANGIBLE, VAL_NOVAL},
	VAL_NO},
{"IOP_PR_RGRAPH",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_NO},
{"IOP_MC",
	{VAL_CTMC, VAL_DTMC, VAL_NOVAL},
	VAL_CTMC},
{"IOP_PR_MC",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_NO},
{"IOP_PR_MC_ORDER",
	{VAL_TOFROM, VAL_FROMTO, VAL_NOVAL},
	VAL_FROMTO},
{"IOP_OK_ABSMARK",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_NO},
{"IOP_OK_VANLOOP",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_NO},
{"IOP_OK_TRANS_M0",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_YES},
{"IOP_DEBUG",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_NO},
{"IOP_USENAME",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_NO},
{"IOP_METHOD",
	{VAL_GASEI, VAL_SSSOR, VAL_TSUNIF, VAL_NOVAL},
	VAL_SSSOR},
{"IOP_ITERATIONS",
	{VAL_NOVAL},
	2000},
{"IOP_PR_PROB",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_NO},
{"IOP_SENSITIVITY",
	{VAL_YES, VAL_NO, VAL_NOVAL},
	VAL_NO}}
# endif
;
/* used to store the integer options */

EX	FD	auxFOpt[N_FOP]
# ifdef MAIN
= {
{"FOP_ABS_RET_M0",	0.0 },
{"FOP_PRECISION",	0.000001}}
# endif
;

/* used to store the floating point options */
/* was = &auxFOpt[-N_IOP] - why? - Dead code? */
EX	FD	*FOpt
# ifdef MAIN
= &auxFOpt[N_FOP]
# endif
;
/* a shift of auxFOpt */

/* declare the external functions */
extern	EE	*get_EE();
extern	ME	*get_ME();
extern	LL	*get_LL();
extern	char	*new_mem();
extern	int	getanswer();
/* extern	SPRINTFTYPE sprintf(); */

# undef EX
